/*
** main.c
**
** Nokia 3310/5110 Example Program
** Target: ATMEGA :: AVR-GCC
**
** Written by Tony Myatt - 2007
** Quantum Torque - www.quantumtorque.com
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "lcd.h"

static unsigned char buffer[6][84];
/* ship coordinates */
static unsigned char x_ship = 40; 
/* projectile coordinates */
static unsigned char x_proj, y_proj = 41; 
/* enemy coordinates */
static unsigned char x_enemy = 41, y_enemy = 5; 

/* enemy movement mechanism */
static char x_e_step;
static unsigned char x_e_counter, y_e_counter;
/* enemy representation */
static unsigned char enemymap[3][9]; 
/* nr enemies alive */
static unsigned char enemies_alive;

static unsigned char lives = 3;


unsigned char battleship[5][5] = {{0,0,1,0,0},
						  {0,1,1,1,0},
						  {0,1,0,1,0},
						  {1,1,1,1,1},
						  {1,1,1,1,1}};


unsigned char projectile[5][5] = {{0,0,0,0,0},
						  {0,0,1,0,0},
						  {0,1,1,1,0},
						  {0,0,1,0,0},
						  {0,0,0,0,0}};
  
unsigned char enemy[5][5] = {{0,0,1,0,0},
						  {0,0,1,0,0},
						  {0,1,1,1,0},
						  {0,0,1,0,0},
						  {0,1,0,1,0}};
						  
void init_buttons()
{
	DDRA &= ~(1 << PA0);  
	PORTA |= (1 << PA0);  
	
	DDRA &= ~(1 << PA2);  
	PORTA |= (1 << PA2);  
	
	DDRA &= ~(1 << PA1);  
	PORTA |= (1 << PA1);  
}

/* initializes the enemies for the start of the game */
void initEnemies(void)
{
	int i, j;
	
	x_enemy = 41;
	y_enemy = 5;
	x_e_counter = 0;
	x_e_step = 1;
	y_e_counter = 0;
	
	for(i = 0; i < 3; i++)
		for(j = 0; j < 9; j++)
			enemymap[i][j] = 1;
			
	enemies_alive = 27;	
}

void gameOver(void) {
	lcd_goto_xy_exact(0,0);
	lcd_goto_xy(4,3);
	lcd_str("GAME OVER");
}

void finish(void) {
	lcd_goto_xy_exact(0,0);
	lcd_goto_xy(4,3);
	lcd_str("WELL DONE");
}

void start_screen()
{
	lcd_clear();
	lcd_goto_xy_exact(0,0);
	lcd_goto_xy(1,2);
	lcd_str("Space Invaders");
	lcd_goto_xy(4,3);
	lcd_chr(ARROW_LEFT);
	lcd_str("2019");
	lcd_chr(ARROW_RIGHT);
	
	_delay_ms(100);
	
	while(PINA & (1 << PA2));
}

int main(void)
{	
	
	
	/* Setup LCD */
 	lcd_init();
	lcd_contrast(0x40);
	
	init_buttons();
	
	start_screen();
	//initEnemies();
	
	while(1)
	{
		

		_delay_ms(300);

		
		if (lives == '0') {
			gameOver();
			break;
		}
		
		/* check if game ended */
		else if (enemies_alive == 0) {
			finish();
			break;
		}
	}
}

